﻿using Syncfusion.SfCalendar.XForms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using Xamarin.Forms;

namespace CalendarAppointment
{
    public class CalendarViewModel : INotifyPropertyChanged
    {
        public CalendarEventCollection Appointments { get; set; }

        public DateTime Date { get; set; }

        public string AppCount { get; set; }

        public bool IsAppointment { get; set; }


        public event PropertyChangedEventHandler PropertyChanged;

        public CalendarViewModel()
        {
            this.AddAppointments();
        }

        private void AddAppointments()
        {
            Appointments = new CalendarEventCollection();
            var random = new Random();
            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddHours(10),
                EndTime = DateTime.Now.Date.AddHours(12),
                Subject = "Meeting",
                Color = Color.Red
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(1).AddHours(10),
                EndTime = DateTime.Now.Date.AddDays(1).AddHours(12),
                Subject = "Planning",
                Color = Color.Blue
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(1).AddHours(15),
                EndTime = DateTime.Now.Date.AddDays(1).AddHours(17),
                Subject = "Execution",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(2).AddHours(10),
                EndTime = DateTime.Now.Date.AddDays(2).AddHours(12),
                Subject = "Meeting",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(2).AddHours(13),
                EndTime = DateTime.Now.Date.AddDays(2).AddHours(15),
                Subject = "Planning",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(2).AddHours(15),
                EndTime = DateTime.Now.Date.AddDays(2).AddHours(17),
                Subject = "Execution",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(3).AddHours(10),
                EndTime = DateTime.Now.Date.AddDays(3).AddHours(12),
                Subject = "Scrum Meeting",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(3).AddHours(13),
                EndTime = DateTime.Now.Date.AddDays(3).AddHours(15),
                Subject = "Product Planning",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(3).AddHours(15),
                EndTime = DateTime.Now.Date.AddDays(3).AddHours(17),
                Subject = "Execution",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(3).AddHours(17),
                EndTime = DateTime.Now.Date.AddDays(3).AddHours(18),
                Subject = "Review Meeting",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(4).AddHours(09),
                EndTime = DateTime.Now.Date.AddDays(4).AddHours(10),
                Subject = "Scrum Meeting",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(4).AddHours(11),
                EndTime = DateTime.Now.Date.AddDays(4).AddHours(13),
                Subject = "Product Planning",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(4).AddHours(15),
                EndTime = DateTime.Now.Date.AddDays(4).AddHours(17),
                Subject = "Plan Execution",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(4).AddHours(17),
                EndTime = DateTime.Now.Date.AddDays(4).AddHours(18),
                Subject = "Review Meeting",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(4).AddHours(18),
                EndTime = DateTime.Now.Date.AddDays(4).AddHours(19),
                Subject = "Testing",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

            Appointments.Add(new CalendarInlineEvent()
            {
                StartTime = DateTime.Now.Date.AddDays(4).AddHours(18),
                EndTime = DateTime.Now.Date.AddDays(4).AddHours(19),
                Subject = "Testing",
                Color = Color.FromRgb(random.Next(0, 255), random.Next(0, 255), random.Next(0, 255))
            });

           

        }

        private void RaisePropertyChanged(String Name)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(Name));
        }
    }
}
